import socks
from httplib2 import parse_uri

def parse_proxy(uri):
    """
        (scheme, user_name, password, authority, port, path, query, fragment) = parse_proxy(uri)
    """
    groups=parse_uri(uri)
    user_name=None
    password=None
    port=8080
    proxy_type=None

    if groups[0] in ["socks","tor"]:
        port=9050
        proxy_type=socks.PROXY_TYPE_SOCKS5
    elif groups[0]=="socks4":
        port=9050
        proxy_type=socks.PROXY_TYPE_SOCKS4
    elif groups[0]=="connect":
        port=3128
        proxy_type=socks.PROXY_TYPE_HTTP

    server=groups[1]
    if groups[1].find("@")>0:
        creds,server=groups[1].split("@")
        if creds.find(":")>0:
            user_name,password=creds.split(":")
    if server.find(":")>0:
        server,s_port=server.split(":")
        if s_port.isdigit():
            port=int(s_port)

    return (proxy_type,user_name,password,server,port,groups[2],groups[3],groups[4])


